
#include "ST7565_homephone.h"
// add a bitmap library of a 16x16 fruit icon
#include "bmps.h"

ST7565 lcd(3,4,5,6);

 
const static unsigned char __attribute__ ((progmem)) ga_mai_16x16[]= {
0x20, 0xD8, 0x2C, 0x0C, 0x9E, 0x72, 0x42, 0xC0, 0x40, 0x40, 0x60, 0xFC, 0xCE, 0x3B, 0x7B, 0x01,
0x00, 0x06, 0x09, 0x10, 0x30, 0x48, 0x44, 0x4E, 0x59, 0x71, 0x39, 0x1F, 0x0E, 0x00, 0x00, 0x00
};
/* Qủa trứng (6x7) pixel
 *  */
 
const static unsigned char __attribute__ ((progmem)) trung_6x7 [] = {
0x1C, 0x22, 0x41, 0x41, 0x22, 0x1C, 
};

byte Xmin, Ymin,Xmax, Ymax;//biên
// mảng cho 2 đối tượng gà(0) và trứng(1)
byte object[2][4];
//object[i][0]: tồn tại hay không
//object[i][1]: tọa độ x
//object[i][2]: tọa độ y
//object[i][3]: hướng (1 phải, 2 trên , 3 trái, 4 dưới)
//
// Chương trình chạy 1 lần
void setup()   {             
  lcd.ON(); 
  lcd.SET(23,0,0,0,4);
  
Xmin=0;
Xmax=125;
Ymin=0;
Ymax=63;

}
void ve_ga_di( ){
  byte x_cu, y_cu, huong_cu;
  byte x_moi;
  x_cu=object[0][1];
  y_cu=object[0][2];
  huong_cu=object[0][3];
  //lấy thông tin 
  
if(huong_cu==1){//gà quay về bên phải
  x_moi=x_cu+1;
  lcd.Plus_Bitmap(x_moi, y_cu, 16,16,ga_mai_16x16,0,MIRROR,BLACK);
  // xoay bitmap (mirror)
  //
}

if(huong_cu==3){//gà quay về bên trái
  x_moi=x_cu-1;
  lcd.Plus_Bitmap(x_moi, y_cu, 16,16,ga_mai_16x16, 0,NO_MIRROR,BLACK);
  // không xoay (non mirror)
}
//ghi lại thông tin
object[0][1]=x_moi;
lcd.display();
  
}//vẽ gà
void xoa_ga( byte x, byte y){
  lcd.FillRect(x,y, 16,16,DELETE);//
  lcd.display();
}//xóa gà
void ga_di_va_de_trung(){// gà đi và đẻ trứng
  //////////// XỬ LÍ GÀ////////////
  //b1: cấp giấy khai sinh
if(object[0][0]==0){
  // nếu không tồn tại gà thì phải tạo gà
  // cấp thuộc tính cho đối tượng gà
  object[0][1]=Xmin+5;//hoành độ ban đầu
  object[0][2]= Ymin; // tung độ ban đầu
  object[0][3]= 1;//hướng sang bên phải
  object[0][0]=1; //cấp quyền tồn tại
}
//b2: gà đi và quay đầu
//lấy thông tin;
if(object[0][1]<=Xmin){
  // nếu gà đến biên trái thì phải quay đầu về bên phải
  object[0][3]=1;
//ghi lại thông tin
}

if(object[0][1]>=Xmax){
  // nếu gà đến biên phải thì phải quay đầu về bên trái
  object[0][3]=3;
//ghi lại thông tin
}
  ///////////GÀ ĐANG ĐI/////////
  // lấy tt
  
  xoa_ga( object[0][1], object[0][2]);//xóa ảnh cũ
ve_ga_di();// vẽ ảnh mới

  
}
void loop() {


ga_di_va_de_trung();
  delay(100);
}
